<?php

namespace app\common\model\school\classes\hourorder;

use think\Model;
use app\common\model\BaseModel;

class OrderLog extends BaseModel
{

    

    

    // 表名
    protected $name = 'school_classes_hour_order_log';
    
    // 自动写入时间戳字段
    protected $autoWriteTimestamp = 'integer';

    // 定义时间戳字段名
    protected $createTime = 'createtime';
    protected $updateTime = false;
    protected $deleteTime = false;

    // 追加属性
    protected $append = [
        'status_text'
    ];
    

    
    public function getStatusList()
    {
        return ['-3' => __('Status -3'),'-1' => __('Status -1'), '0' => __('Status 0'), '3' => __('Status 3')];
    }


    public function getStatusTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['status']) ? $data['status'] : '');
        $list = $this->getStatusList();
        return isset($list[$value]) ? $list[$value] : '';
    }




    public function hourorder()
    {
        return $this->belongsTo(Order::class, 'classes_hour_order_id', 'id', [], 'LEFT')->setEagerlyType(0);
    }



    /**记录订单日志
     * @param $params
     * @param bool $trans
     * @throws \Exception
     */
    public static function log($order,$mark='更新订单状态',$oper_type='user',$oper_id = 0,$trans=false){
//        var_dump($order);
        if(is_numeric($order)||is_string($order))$order = Order::where('order_no|id',$order)->find();


        if(!$order)throw new \Exception("找不到订单");
        //操作人信息（可扩展）
        $data = [
            'oper_type'=>$oper_type ?: 'user',
            'oper_id'=>$oper_id ?: $order['user_id'],
            'remark'=>$mark,
        ];
        //判断逻辑
        if($trans){
            self::beginTrans();
        }
        $res = true;
        try{
            //事务逻辑
            $log_data = $order->toArray();
            $log_data["classes_hour_order_id"] = $order['id'];
            unset($log_data['id']);
            unset($log_data['createtime']);
            if($mark)$log_data['log_text'] = $mark;


            $log_data = array_merge($log_data,$data);

            $log = (new self);
            $log->allowField(true)->save($log_data);
            if($trans){
                self::commitTrans();
            }
        }catch (\Exception $e){
            if($trans){
                self::rollbackTrans();
            }
            throw new \Exception($e->getMessage());
        }
        return $log;
    }




    /**得到基础条件
     * @param $status
     * @param null $model
     * @param string $alisa
     */
    public static function getBaseWhere($whereData = [], $model = null, $alisa = '',$with = false)
    {

        if (!$model) {
            $model = new static;
            if ($alisa&&!$with) $model = $model->alias($alisa);
        }
        if ($alisa) $alisa = $alisa . '.';
        $tableFields = (new static)->getTableFields();
        foreach ($tableFields as $fields)
        {
            if(in_array($fields, ['status','auth_status','classes_hour_order_id']))continue;
//            if (isset($whereData[$fields]) && $whereData[$fields]) $model = $model->where("{$alisa}{$fields}", '=', $whereData[$fields]);

            if (isset($whereData[$fields]) && $whereData[$fields]){
                if(is_array($whereData[$fields])){
                    $model = $model->where("{$alisa}{$fields}", $whereData[$fields][0], $whereData[$fields][1]);
                }else{
                    $model = $model->where("{$alisa}{$fields}", '=', $whereData[$fields]);
                }

            }

        }
        if (isset($whereData['status']) && $whereData['status']) $model = $model->where("{$alisa}status", 'in', $whereData['status']);

        if (isset($whereData['not_status'])) $model = $model->where("{$alisa}status", 'not in', $whereData['not_status']);

        if (isset($whereData['auth_status']) && $whereData['auth_status']) $model = $model->where("{$alisa}auth_status", 'in', $whereData['auth_status']);

        if (isset($whereData['not_auth_status'])) $model = $model->where("{$alisa}auth_status", 'not in', $whereData['not_auth_status']);



        if (isset($whereData['keywords'])&&$whereData['keywords']) $model = $model->where("{$alisa}id|{$alisa}classes_hour_order_id|{$alisa}log_text", 'LIKE', "%".$whereData['keywords']."%");
        if (isset($whereData['time'])&&$whereData['time']){

            $model = $model->time(["{$alisa}createtime",$whereData['time']]);
        }
        if (isset($whereData['classes_hour_order_id']) && $whereData['classes_hour_order_id']) $model = $model->where("{$alisa}classes_hour_order_id", 'in', $whereData['classes_hour_order_id']);


        return $model;
    }






    public static function allList($user_id,$page, $limit,$keywords,$status,$auth_status,$classes_hour_order_id=[]){
        $with_field = [
            'hourorder'=>['*'],
            'base'=>['*'],
//            'classesorder'=>['*'],
//            'detail'=>['*'],
        ];

        $alisa = (new self)->getWithAlisaName();
        $sort = "{$alisa}.id desc";
        $serch_where = ['status'=>$status,'user_id'=>$user_id,
            'keywords'=>$keywords,"classes_hour_order_id"=>$classes_hour_order_id,
            "service_stauts"=>$auth_status
        ];
//        if($type)$serch_where['type'] = $type;
        return (new self)->getBaseList($serch_where, $page, $limit,$sort,$with_field);
    }



}
